Bug 128314 - SCSI read packet sizes limited to 32kb???
SCSI read packet sizes limited to 32kb???
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Doug Ledford
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2004-07-21 14:02 EDT by Gunther Schadow
Modified: 2007-11-30 17:07 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-09-21 10:15:40 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Gunther Schadow 2004-07-21 14:02:44 EDT
Description of problem:

I am grappling with IO bottleneck issues on Xeon servers 
running RHEL3. They seem to max out IO capacity at 
30-40 MB/s. Some say that's expected, but no normal
ranges are anywere to be found. Still I think there is 
room for improvement.

We do 2 Gb/s FibreChannel to an EMC Symmetrix and I 
have the EMC engineer make statistics of the EMC device
while I do a simple read test with

dd bs=65536 if=/dev/sda1 of=/dev/null

I also alter vm.max-readahead in two test to be 1023
and 127 respectively.

I expect to see the read sizes on the EMC to change. 

- I expect them to be 64 kB minimum, because I set
  read buffer size to 65536 on dd.

- I expect them to be 64 kB when vm.max-readahead is

- I expect them to grow up to 512 kB when I set vm.max-
  readahead to 1023

Yet, in all cases the EMC gets read requests of 32 kB


- is there a hard limit in the linux kernel for IO buffers?

- is there a hard limit in the QLogic 2200 driver?

- is there a limit on the QLogic card itself?

- is there a sysctl parameter that I can set to crank the
  maximum transfer size up to at least 128 kB?

Version-Release number of selected component (if applicable):

kernel: 2.4.21-15.0.3.ELsmp

QLA driver version 6.07.02-RH2

How reproducible:
Steps to Reproduce:

see above

Actual results:

32kB transfer sizes on the SAN disk array.

Expected results:

64kB and 512kB transfer sizes on the SAN disk array.
Comment 1 Gunther Schadow 2004-07-23 16:38:06 EDT
I need to add that there is no hard limit configured on the HBA, I 
just checked that. So, the HBA is not doing the fragmenting.

The EMC people say they like to see 128kB request sizes, so it's not 
them breaking it up into 32k fragments either.
Comment 2 Gunther Schadow 2004-08-10 18:38:45 EDT
Will there be any action on this? I have submitted this weeks ago and 
no news at all?

Thanks for your attention.
Comment 3 Doug Ledford 2006-09-19 18:50:02 EDT
This problem was likely from a scatter gather limit in the QLogic driver.  Given
the QLogic driver has been updated several times since this bug report, does
this problem still exist with the latest RHEL3 update?  If not, it should be closed.
Comment 4 Rob Kenna 2006-09-21 10:15:40 EDT
Given where RHEL 3 is in it's lifecycle, the age of the last customer comment,
plus the possibility the QLA driver might have solved this issue, I'm closing
this out.  Re-open if you feel differently.

Note You need to log in before you can comment on or make changes to this bug.